"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addHelpCommandToCli = void 0;
const help_1 = require("./commands/help");
const addHelpCommandToCli = function ({ rootCommand }) {
    return {
        name: rootCommand.name,
        description: rootCommand.description,
        remarks: rootCommand.remarks,
        optionDefinitions: [
            ...rootCommand.optionDefinitions
        ],
        ignoreUnknownOptions: rootCommand.ignoreUnknownOptions,
        subcommands: {
            ...rootCommand.subcommands,
            help: help_1.helpCommand
        },
        handle: rootCommand.handle
    };
};
exports.addHelpCommandToCli = addHelpCommandToCli;
